= How do I use Selenium Server to execute my Selenium tests for my project? =
[[TOC(heading=How do I...?,depth=1,HowTo/*)]]

Selenium Server can be configured to expand your testing coverage, and allow for your tests to run in parallel. It 
is important to ensure that your tests are threadsafe and all testing dependencies are set either by making them 
self contained, or by using [wiki:HowTo/AddTestNG TestNG] to setup expected dependencies.

== Introduction ==
Grid allows you to :
 * scale by distributing tests on several machines ( parallel execution )
 * manage multiple environments from a central point, making it easy to run the tests against a vast combination of browsers / OS.
 * minimize the maintenance time for the grid by allowing you to implement custom hooks to leverage virtual infrastructure for instance.
 
== Quick Start ==
This example will show you how to start the Selenium 2 Hub, and register a !WebDriver node. We’ll also show you how to call the 
grid from Java. The hub and nodes are shown here running on the same machine, but of course you can copy the 
selenium-server-standalone to multiple machines.

=== Step 1: Start the hub ===

The Hub is the central point that will receive all the test request and distribute them the the right nodes.

Open a command prompt and navigate to the directory where you copied the selenium-server-standalone file. Type the following command:

{{{
java -jar <%= node['tools']['base_dir'] %>/selenium-server-<%= node['tools']['selenium-server']['version'] %>.jar -role hub
}}}
The hub will automatically start-up using port 4444 by default. To change the default port, you can add the optional parameter 
-port when you run the command. You can view the status of the hub by opening a browser window and navigating to: 
[//grid /grid] as our proxy has this already configured. 
Because Selenium is trying to load a jquery over http, for the best experience, tell your browser it is OK to load the insecure content.
Here are some instructions for doing this in [http://superuser.com/questions/487748/how-to-allow-chrome-browser-to-load-insecure-content Chrome], [http://wiki.sln.suny.edu/display/SLNKB/Enabling+mixed+content+in+Mozilla+Firefox Firefox], and [http://answers.microsoft.com/en-us/ie/forum/ie9-windows_vista/how-can-i-turn-off-the-secureinsecure-content/5f2ba4c3-3ae9-4b58-b8cf-d8c3f6471313 Internet Explorer].  

=== Step 2: Start the nodes ===

You use the same selenium-server-standalone jar file to start the nodes.

{{{
java -jar <%= node['tools']['base_dir'] %>/selenium-server-<%= node['tools']['selenium-server']['version'] %>.jar -role node  -hub http://localhost:4444/grid/register
}}}
Note: The port defaults to 5555 if not specified whenever the "-role" option is provided and is not hub.

== Using grid to run tests ==

Now that the grid is in-place, we need to access the grid from our test cases. 

You will need to use the !RemoteWebDriver and the !DesiredCapabilities object to define which browser, 
version and platform you wish to use. Create the target browser capabilities you want to run the tests against:

{{{
DesiredCapabilities capability = DesiredCapabilities.firefox();
}}}
Pass that into the !RemoteWebDriver object:

{{{
WebDriver driver = new RemoteWebDriver(new URL("http://localhost:4444/wd/hub"), capability);
}}}
The hub will then assign the test to a matching node.

A node matches if all the requested capabilities are met. To request specific capabilities on the grid, specify them 
before passing it into the !WebDriver object.

== More Information ==

* [https://code.google.com/p/selenium/wiki/Grid2 Selenium Grid]

<%= node['trac']['wiki']['footer'] %>